Package io.vertx.circuitbreaker

## Interface CircuitBreaker

-     public interface CircuitBreaker

  An implementation of the circuit breaker pattern for Vert.x
  Author:
    Clement Escoffier

- - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `CircuitBreaker` | `close()` | Closes the circuit breaker.
    `CircuitBreaker` | `closeHandler​(Handler<Void> handler)` | Sets a `Handler` to be invoked when the circuit breaker state switches to closed.
    `static CircuitBreaker` | `create​(String name, Vertx vertx)` | Creates a new instance of `CircuitBreaker`, with default options.
    `static CircuitBreaker` | `create​(String name, Vertx vertx, CircuitBreakerOptions options)` | Creates a new instance of `CircuitBreaker`.
    `<T> Future<T>` | `execute​(Handler<Promise<T>> command)` | Same as `executeWithFallback(Handler, Function)` but using the circuit breaker default fallback.
    `<T> Future<T>` | `execute​(java.util.function.Supplier<Future<T>> command)` | Same as `executeWithFallback(Supplier, Function)` but using the circuit breaker default fallback.
    `<T> CircuitBreaker` | `executeAndReport​(Promise<T> resultPromise, Handler<Promise<T>> command)` | Same as `executeAndReportWithFallback(Promise, Handler, Function)` but using the circuit breaker default fallback.
    `<T> CircuitBreaker` | `executeAndReportWithFallback​(Promise<T> resultPromise, Handler<Promise<T>> command, java.util.function.Function<Throwable,​T> fallback)` | Executes the given operation with the circuit breaker control.
    `<T> Future<T>` | `executeWithFallback​(Handler<Promise<T>> command, java.util.function.Function<Throwable,​T> fallback)` | Executes the given operation with the circuit breaker control.
    `<T> Future<T>` | `executeWithFallback​(java.util.function.Supplier<Future<T>> command, java.util.function.Function<Throwable,​T> fallback)` | Executes the given operation with the circuit breaker control.
    `long` | `failureCount()` |
    `default <T> CircuitBreaker` | `failurePolicy​(FailurePolicy<T> failurePolicy)` | Configures the failure policy for this circuit-breaker.
    `<T> CircuitBreaker` | `fallback​(java.util.function.Function<Throwable,​T> handler)` | Sets a default fallback `Function` to be invoked when the circuit breaker is open or when failure occurs and `CircuitBreakerOptions.isFallbackOnFailure()` is enabled.
    `CircuitBreaker` | `halfOpenHandler​(Handler<Void> handler)` | Sets a `Handler` to be invoked when the circuit breaker state switches to half-open.
    `String` | `name()` |
    `CircuitBreaker` | `open()` | Explicitly opens the circuit breaker.
    `CircuitBreaker` | `openHandler​(Handler<Void> handler)` | Sets a `Handler` to be invoked when the circuit breaker state switches to open.
    `CircuitBreaker` | `reset()` | Resets the circuit breaker state.
    `CircuitBreaker` | `retryPolicy​(RetryPolicy retryPolicy)` | Set a `RetryPolicy` which computes a delay before a retry attempt.
    `CircuitBreaker` | `retryPolicy​(java.util.function.Function<Integer,​Long> retryPolicy)` | Deprecated. use `retryPolicy(RetryPolicy)` instead
    `CircuitBreakerState` | `state()` |

- - ### Method Detail

    - #### create

          static CircuitBreaker create​(String name,
                                       Vertx vertx,
                                       CircuitBreakerOptions options)

      Creates a new instance of `CircuitBreaker`.
      Parameters:
        `name` - the name
        `vertx` - the Vert.x instance
        `options` - the configuration options
      Returns:
        the created instance

    - #### create

          static CircuitBreaker create​(String name,
                                       Vertx vertx)

      Creates a new instance of `CircuitBreaker`, with default options.
      Parameters:
        `name` - the name
        `vertx` - the Vert.x instance
      Returns:
        the created instance

    - #### close

          CircuitBreaker close()

      Closes the circuit breaker. It stops sending events on its state on the event bus.

      This method is not related to the `closed` state of the circuit breaker. To move the circuit breaker to the `closed` state, use `reset()`.

    - #### openHandler

          CircuitBreaker openHandler​(Handler<Void> handler)

      Sets a `Handler` to be invoked when the circuit breaker state switches to open.
      Parameters:
        `handler` - the handler, must not be `null`
      Returns:
        this `CircuitBreaker`

    - #### halfOpenHandler

          CircuitBreaker halfOpenHandler​(Handler<Void> handler)

      Sets a `Handler` to be invoked when the circuit breaker state switches to half-open.
      Parameters:
        `handler` - the handler, must not be `null`
      Returns:
        this `CircuitBreaker`

    - #### closeHandler

          CircuitBreaker closeHandler​(Handler<Void> handler)

      Sets a `Handler` to be invoked when the circuit breaker state switches to closed.
      Parameters:
        `handler` - the handler, must not be `null`
      Returns:
        this `CircuitBreaker`

    - #### executeWithFallback

          <T> Future<T> executeWithFallback​(Handler<Promise<T>> command,
                                            java.util.function.Function<Throwable,​T> fallback)

      Executes the given operation with the circuit breaker control. The operation is generally calling an external system. The operation receives a `Promise` object as parameter and must call `Promise.complete(Object)` when the operation has terminated successfully. The operation must also call `Promise.fail(Throwable)` in case of a failure.

      The operation is not invoked if the circuit breaker is open, and the given fallback is called instead. The circuit breaker also monitors whether the operation completes in time. The operation is considered failed if it does not terminate before the configured timeout.

      This method returns a `Future` object to retrieve the status and result of the operation, with the status being a success or a failure. If the fallback is called, the returned future is successfully completed with the value returned from the fallback. If the fallback throws an exception, the returned future is marked as failed.

      Type Parameters:
        `T` - the type of result
      Parameters:
        `command` - the operation
        `fallback` - the fallback function; gets an exception as parameter and returns the fallback result
      Returns:
        a future object completed when the operation or the fallback completes

    - #### executeWithFallback

          <T> Future<T> executeWithFallback​(java.util.function.Supplier<Future<T>> command,
                                            java.util.function.Function<Throwable,​T> fallback)

      Executes the given operation with the circuit breaker control. The operation is generally calling an external system. The operation receives a `Promise` object as parameter and must call `Promise.complete(Object)` when the operation has terminated successfully. The operation must also call `Promise.fail(Throwable)` in case of a failure.

      The operation is not invoked if the circuit breaker is open, and the given fallback is called instead. The circuit breaker also monitors whether the operation completes in time. The operation is considered failed if it does not terminate before the configured timeout.

      This method returns a `Future` object to retrieve the status and result of the operation, with the status being a success or a failure. If the fallback is called, the returned future is successfully completed with the value returned from the fallback. If the fallback throws an exception, the returned future is marked as failed.

      Type Parameters:
        `T` - the type of result
      Parameters:
        `command` - the operation
        `fallback` - the fallback function; gets an exception as parameter and returns the fallback result
      Returns:
        a future object completed when the operation or the fallback completes

    - #### execute

          <T> Future<T> execute​(Handler<Promise<T>> command)

      Same as `executeWithFallback(Handler, Function)` but using the circuit breaker default fallback.
      Type Parameters:
        `T` - the type of result
      Parameters:
        `command` - the operation
      Returns:
        a future object completed when the operation or its fallback completes

    - #### execute

          <T> Future<T> execute​(java.util.function.Supplier<Future<T>> command)

      Same as `executeWithFallback(Supplier, Function)` but using the circuit breaker default fallback.
      Type Parameters:
        `T` - the type of result
      Parameters:
        `command` - the operation
      Returns:
        a future object completed when the operation or its fallback completes

    - #### executeAndReport

          <T> CircuitBreaker executeAndReport​(Promise<T> resultPromise,
                                              Handler<Promise<T>> command)

      Same as `executeAndReportWithFallback(Promise, Handler, Function)` but using the circuit breaker default fallback.
      Type Parameters:
        `T` - the type of result
      Parameters:
        `resultPromise` - the promise on which the operation result is reported
        `command` - the operation
      Returns:
        this `CircuitBreaker`

    - #### executeAndReportWithFallback

          <T> CircuitBreaker executeAndReportWithFallback​(Promise<T> resultPromise,
                                                          Handler<Promise<T>> command,
                                                          java.util.function.Function<Throwable,​T> fallback)

      Executes the given operation with the circuit breaker control. The operation is generally calling an external system. The operation receives a `Promise` object as parameter and must call `Promise.complete(Object)` when the operation has terminated successfully. The operation must also call `Promise.fail(Throwable)` in case of a failure.

      The operation is not invoked if the circuit breaker is open, and the given fallback is called instead. The circuit breaker also monitors whether the operation completes in time. The operation is considered failed if it does not terminate before the configured timeout.

      Unlike `executeWithFallback(Handler, Function)`, this method does not return a `Future` object, but lets the caller pass a `Promise` object on which the result is reported. If the fallback is called, the promise is successfully completed with the value returned by the fallback function. If the fallback throws an exception, the promise is marked as failed.

      Type Parameters:
        `T` - the type of result
      Parameters:
        `resultPromise` - the promise on which the operation result is reported
        `command` - the operation
        `fallback` - the fallback function; gets an exception as parameter and returns the fallback result
      Returns:
        this `CircuitBreaker`

    - #### fallback

          <T> CircuitBreaker fallback​(java.util.function.Function<Throwable,​T> handler)

      Sets a default fallback `Function` to be invoked when the circuit breaker is open or when failure occurs and `CircuitBreakerOptions.isFallbackOnFailure()` is enabled.

      The function gets the exception as parameter and returns the fallback result.

      Parameters:
        `handler` - the fallback handler
      Returns:
        this `CircuitBreaker`

    - #### failurePolicy

          default <T> CircuitBreaker failurePolicy​(FailurePolicy<T> failurePolicy)

      Configures the failure policy for this circuit-breaker.
      Returns:
        the current `CircuitBreaker`
      See Also:
        `FailurePolicy`

    - #### reset

          CircuitBreaker reset()

      Resets the circuit breaker state. The number of recent failures is set to 0 and if the state is half-open, it is set to closed.
      Returns:
        this `CircuitBreaker`

    - #### open

          CircuitBreaker open()

      Explicitly opens the circuit breaker.
      Returns:
        this `CircuitBreaker`

    - #### state

          CircuitBreakerState state()

      Returns:
        the current state of this circuit breaker

    - #### failureCount

          long failureCount()

      Returns:
        the current number of recorded failures

    - #### name

          String name()

      Returns:
        the name of this circuit breaker

    - #### retryPolicy

          @Deprecated
          CircuitBreaker retryPolicy​(java.util.function.Function<Integer,​Long> retryPolicy)

      Deprecated.
      use `retryPolicy(RetryPolicy)` instead

    - #### retryPolicy

          CircuitBreaker retryPolicy​(RetryPolicy retryPolicy)

      Set a `RetryPolicy` which computes a delay before a retry attempt.